;This file is copyright (c) 1992, Informant Communications Group and the 
;article author. The material here may be used in an application provided 
;that this copyright/disclaimer information is kept in the original source 
;file. The material presented here is provided "as is" and with no guarantee.
;Informant Communications Group/Paradox Informant assumes no responsibility 
;for the use or misuse of the material contained within.  
; 
;Contents        : Source file ONTHEFLY.SC 
;Author          : Micah J. Bleecher - DataStar International
;Informant Issue : August 1992
;Description     : Adding lookup records "on the fly" demo
;
; Paradox Informant
; 10519 E. Stockton Blvd.
; Suite 142
; Elk Grove, CA  95624-9743
; Phone: (916) 686-6610
; Fax  : (916) 686-8497
; BBS  : (916) 686-4740
;

;======================================================================
;   Procedure: GenericDemoWait.u()
;  Programmer: Micah J. Bleecher, DataStar* of Virginia
;              9314 Monarch Crescent
;              Richmond, VA 23228
;              (804) 672-3207 CIS:76570,234
; Last Update: 4/19/92  11:10:58
; Description: Generic Wait handler to demonstrate adding lookup
;              records "On the Fly"
;
;
;====================================================================

Proc GenericDemoWait.u()

  Private proc.a,quitmenu.a,prompt1.a,prompt2.a,addrecord.l

  proc.a="GenericDemoWait.u"

  View "Customer"   ;Customer.F1
  PickForm 1

  Prompt1.a="Generic Wait with `On the Fly Lookup'"
  Prompt2.a="[F9]-Edit [Esc]-Quit"

  While (True)

    Wait Table
      Prompt Prompt1.a,prompt2.a

    Until "ZOOM","ZOOMNEXT","DOS","DOSBIG","F2","F9","ESC","F1","PGUP","PGDN",
    "UP","LEFT","REVERSETAB","RIGHT","TAB","ENTER","DOWN","INS"

    Switch

      Case RetVal = "F1" :         ;lookup
        If SysMode() = "Main" Then  ;trap for Main mode
          Beep
          Loop
        EndIf

        ;=======================================================
        ; LookandFill.l() from last months Informant  (May 92)
        ;=======================================================

        addrecord.l=LookAndFill.l(True,True,True)

        If Addrecord.l Then              ;If true then user pressed INS in
          AddOnTheFly.u(Table(),field()) ;lookup table. Call AddontheFly.u()
        EndIf

        ;=======================================================
        ; Note that in Wait Plus Pro, the call would be made the
        ; same way, immediatly following the call to
        ; LookAndFill.l()
        ;=======================================================


      Case RetVal = "F2" :

        Prompt1.a="Generic Wait with `On the Fly Lookup'"
        Prompt2.a="[F9]-Edit [Esc]-Quit"
        Do_it!

      Case RetVal = "F9" :              ;Enter CoEdit Mode
        If SysMode() = "CoEdit" Then
          Beep
        Else
          CopyToArray thisrec.r         ;Save origional in case
          CoEditKey                     ;Of Cancel
          ImageRights UpDate
          Prompt1.a="Generic Wait with `On the Fly Lookup'" ;CoEdit Prompt
          Prompt2.a="[F1]-Lookup [F2]-Save [Esc]-Cancel"
        EndIf

      Case RetVal = "ESC":   ;Escape handler - allows user to restore
                             ;origional record if in Coedit

        If SysMode() = "Main" Then
          ClearImage
          QuitLoop
        Else
          ShowMenu
            "CancelEdit" : "Restore origional record",
            "ResumeEdit" : "Continue editing"
          To QuitMenu.a
          If QuitMenu.a = "CancelEdit" Then
            CopyFromArray Thisrec.r
            Prompt1.a="Generic Wait with `On the Fly Lookup'"
            Prompt2.a="[F9]-Edit [Esc]-Quit" ;Main mode prompt
            Do_it!
            Loop
          Else
            Loop
          EndIf
        EndIf

        ;=================================================================
        ; Field Movement Keys - Trapping for these keys allows us to keep
        ;                       the user where we want them at all times.
        ;                       In this case, off of Page 2 of
        ;                       Customer F1
        ;=================================================================

      Case RetVal = "PGUP" :    ;Keep user off of Page 2 of form
        If AtFirst() Then       ;force record movement
          Beep
        Else
          Skip -1
        EndIf

      Case RetVal = "PGDN" :   ;Keep user off of Page 2 of form
        If AtLast() Then       ;force record movement
          Beep
        Else
          Skip 1
        EndIf

      Case RetVal = "UP" :
        If Search(","+Field()+",",",CUSTOMER,CUSTID,") > 0 Then
          Beep                                 ;check for first
        Else                                   ;row on form
          Up
        EndIf

      Case RetVal = "DOWN" :
        If Search(","+Field()+",",",SALESID,SALESPERSON,TERRITORY,") > 0 Then
          Beep                                ;check for last
        Else                                  ;row on form
          Down
        EndIf

      Case Search(","+RetVal+",",",RIGHT,TAB,ENTER,") > 0 :
        If Upper(Field()) = "TERRITORY" Then  ;check for last
          Beep                                ;field on form
        Else
          KeyPress RetVal
        EndIf

      Case Search(","+RetVal+",",",LEFT,REVERSETAB,") > 0 :
        If Upper(Field()) = "CUSTID" Then   ;check for first
          Beep                              ;field on form
        Else
          KeyPress RetVal
        EndIf

      Case RetVal = "INS" :
        Beep  ;not allowed for demonstration purposes only

      OtherWise:
        Beep
    EndSwitch



  EndWhile


EndProc


;======================================================================
;   Procedure: AddOnTheFly.u(table.a,field)
;  Programmer: Micah J. Bleecher, DataStar* of Virginia
;              9314 Monarch Crescent
;              Richmond, VA 23228
;              (804) 672-3207 CIS:76570,234
; Last Update: 4/19/92  11:17:11
; Description: Primary procedure to demonstrate adding records on the
;              fly. Note that we are passing the table and field names
;              for context sensitive processing.
;              Calls are made to the following procedures:
;
;              Checkrec.l() ;Record validation routine
;              CheckKey.l() ;Rudimentary key violation checking
;                            routine
;
;====================================================================

Proc Addonthefly.u(table.a,field.a)

  Private proc.a,record.r,keyok.l,recok.l

  proc.a="Addonthefly.u"
                             ;determine which field and table
                             ;to move to
  Switch
   Case Upper(table.a+field.a) = "CUSTOMERSALESID" :
      MoveTo [salesman->salesid]

  EndSwitch

  Ins         ;insert blank record

  While (True)

    Wait Record    ;keep users on one record

      Prompt "Adding record to SalesMan Table",
      "[F2]-Save and Paste [Esc]-Cancel and Return"

    Until "F2","ESC","ZOOM","ZOOMNEXT","DOS","DOSBIG"

    Switch

      Case RetVal = "F2"  :

        recok.l = CheckRec.l(table.a,field.a) ;data validatation
        If Not Recok.l Then
          Loop
        EndIf

        keyok.l = CheckKey.l()    ;check for key violation
        If Not Keyok.l Then
          Loop
        EndIf

        Switch   ;move back to proper table and paste in key value(s)
                 ;from array Addfly.r

          Case Upper(table.a+field.a) = "CUSTOMERSALESID" :
           MoveTo [Customer->Salesid]
           [SalesID]=Addfly.r[2]
           ;Other values could be assigned here

        EndSwitch

        QuitLoop

      Case RetVal = "ESC" :

        Del       ;delete inserted record

        Switch    ;move back to appropriate table

          Case Upper(table.a+field.a) = "CUSTOMERSALESID" :
           MoveTo [Customer->Salesid]

        EndSwitch

        QuitLoop

      OtherWise:
        Beep

    EndSwitch

  EndWhile

EndProc


;======================================================================
;   Procedure: CheckKey.()
;  Programmer: Micah J. Bleecher, DataStar* of Virginia
;              9314 Monarch Crescent
;              Richmond, VA 23228
;              (804) 672-3207 CIS:76570,234
; Last Update: 4/19/92  12:08:33
; Description: Rudimentary key violation checking routine. In full
;              blown applications I most commonly use Alan Zenreich's
;              OkKey35.l() which is much more comprehensive.
;
;====================================================================

Proc CheckKey.l()

  Private proc.a,window.a

  Proc.a="CheckKey.l"

  CopyToArray addfly.r ;grab record contents

  UnLockRecord         ;attempt to post record

  If Not RecordStatus("keyviol") Then    ;test for violation
    Return True
  Else
    Beep
    Message.u("Key Already Exists, Please Use Another",False)
    Sleep 2000
    CtrlHome
    Right            ;return false if key exists
    Return False
  EndIf
EndProc


;======================================================================
;   Procedure: CheckRec.l
;  Programmer: Micah J. Bleecher, DataStar* of Virginia
;              9314 Monarch Crescent
;              Richmond, VA 23228
;              (804) 672-3207 CIS:76570,234
; Last Update: 4/19/92  12:12:47
; Description: Simple record validation routine to determine if
;              the record is complete before key violations are
;              checked.
;              Table and field names are passed for context sensitive
;              processing.
;====================================================================

Proc CheckRec.l(table.a,field.a)

  Private proc.a,fields.n,i

  proc.a="CheckRec.l"

  Switch

   Case Upper(Table.a+Field.a)="CUSTOMERSALESID" :

    MoveTo [SalesId]
    fields.n=NFields(Table())
    For i From 1 To Fields.n
    If IsBlank([]) Then
       Beep
       Message.u("Blank Fields are not allowed",False)
       Sleep 2000
       Return False
    EndIf
     If i <> fields.n Then
       Right
     EndIf
   EndFor
   Return True

  EndSwitch
EndProc

;========================================================================
;
;    The folowing code is from last months Informant Article (May 92)
;
;
;========================================================================


;======================================================================
;   Procedure: LookAndFill.l
;   Copyright: Micah J. Bleecher 1992
;  Programmer: Micah J. Bleecher
; Last Update: 03/09/92
; Description: Enhancement to the LookUp Help and Fill system.
;              Returns False except when [Ins]- Add record is selected
;              Programmer can optionally include Zooming, Vertical View
;              Mode and Add record prompts with formal parameters
;====================================================================

Proc LookAndFill.l(zoomok.l,addrecok.l,vertok.l)
  ;zoomok.l - Allow Zoom
  ;addrecok.l - Allow the addrecord prompt and return
  ;vertok.l - Allow the vertical record display mode

  Private X,proc.a,recret.a,prompt1.a,prompt2.a,barlen.n,barcolor.n

  proc.a = "LookAndFill.l"

  Prompt1.a="Cursor Keys Scroll through Records [\018]"
  Prompt2.a="[F2]-Select Lookup Record [\196\016]-Rotate Columns [\017\196]-Home"

  If vertok.l Then
    prompt1.a=prompt1.a+" [^V]-Vertical View"     ;evaluate optional params
  EndIf

  If zoomok.l Then
    prompt1.a=prompt1.a+" [^Z]-Zoom [Esc]-Quit"
  Else
    prompt1.a=prompt1.a+" [Esc]-Quit"
  EndIf

  If addrecok.l Then
    prompt2.a=prompt2.a+" [Ins]-Insert Record"
  EndIf

  Help
  If HelpMode() <> "LookupHelp" Then   ;test for LookupHelp
    Esc
    SpecialLookup.u(Table(),Field())   ;call special lookups if any
    Return False
  Else
    X = 0
    Echo Off ;Normal
    Prompt Prompt1.a,
    Prompt2.a

    barlen.n=maxbarlen.n()  ;determine bar length based on table width

    While X <> 27 And X <> -60 And X <> -82
      ;escape, F2 and Insert

      Echo Normal Echo Off     ; refresh canvas with workspace
      SyncCursor
      @ Row(), 0 ?? "\016"
      PaintCanvas Attribute SysColor(3) Row(),0,Row(),barlen.n  ; highlight
      Cursor Off
      X=GetChar()    ;trap key characters
      SyncCursor
      PaintCanvas Attribute SysColor(17) Row(),3,Row(),barlen.n  ; un-highlight
      Switch

        Case  X = -75 :  ;Left - Rotate home
          Echo Normal
          Echo Off
          Message "Rotating Table, Please Wait"
          While FieldNo(Field(),Table()) <> 1
            Rotate
          EndWhile
          Left Right
          Loop


        Case  X = 22 :   ;^V - Vertical View Mode

          If vertok.l Then
            recret.a= Recordview.u()
            If recret.a <> -60 Then
              Loop
            Else
              X=recret.a
              KeyPress X   ;paste in value with F2
            EndIf
          Else
            Loop
          EndIf

        Case  X = -77 :  ;Right

          Rotate
          Loop

        Case X = 26 :    ;^Z - Zoom

          If zoomok.l Then
            Zoom.l()  ;Zenriech's Zoom Routine here
          Else
            Beep
          EndIf
          Loop

        Case X = -82 : ;Ins

          If Not addrecok.l Then
            X=0
            Beep
            Loop
          Else
            Esc
            Prompt
            Return True
          EndIf

        Case  Search(StrVal(X),"-80,-72,27,-60,18") > 0 :
          Switch
            Case X =  -80 :
              If AtLast() Then
                Beep
                Loop
              EndIf
            Case X =  -72 :
              If AtFirst() Then
                Beep
                Loop
              EndIf
          EndSwitch

          KeyPress X


        OtherWise :

          Beep

      EndSwitch

    EndWhile
    Echo Off
    Prompt
    Return False

  EndIf

EndProc
;Writelib libname.a LookAndFill.l
;Release Procs LookAndFill.l


;======================================================================
;   Procedure: SpecialLookup.u
;   Copyright: Micah J. Bleecher (c) 1992
;  Programmer: Micah J. Bleecher
; Last Update: 03/09/92
; Description: Called if Helpmode() does not return "LookUpHelp".
;              Alternate context sensitive lookup routines can be
;              hooked in here such as Showmenu or Array based popups
;              etc.
;====================================================================

Proc SpecialLookup.u(table.a,field.a)

  Private proc.a,X

  proc.a = "SpecialLookup.u"

  Switch
    OtherWise :
      Beep
      Message.u("No lookup is available for this field",False)
      Sleep 1000
      While CharWaiting()
        X=GetChar()
      EndWhile
  EndSwitch


EndProc
;Writelib libname.a SpecialLookup.u
;Release Procs SpecialLookup.u

;======================================================================
;   Procedure: MaxBarLen.n()
;   Copyright: Micah J. Bleecher 1992
;  Programmer: Micah J. Bleecher
; Last Update: 03/09/92
; Description: Calculates the length of the light bar in the event
;              the lookup table is more narrow than the screen.
;====================================================================

Proc maxbarlen.n()

  Private maxlen.n,intlen.n,i

  proc.a = "maxbarlen.n"

  CtrlHome    ;calculate first column Length
  Right
  FieldView
  Home
  SyncCursor
  maxlen.n = Col()-3
  End
  Enter
  CtrlHome
  Right
  For i From 1 To NFields(Table())
    Switch
      Case Search("A",FieldType()) > 0 :
        intlen.n=NumVal(Substr(FieldType(),2,Len(FieldType())))
        maxlen.n=maxlen.n+Max(intlen.n+3,Len(Field()))+1
      Case FieldType() = "N" :
        maxlen.n = maxlen.n + Max(15,Len(Field())) + 1
      Case FieldType() = "S" :
        maxlen.n = maxlen.n + Max(9,Len(Field())) + 1
      Case FieldType() = "$" :
        maxlen.n = maxlen.n + Max(18,Len(Field())) + 1
      Case FieldType() = "D" :
        maxlen.n = maxlen.n + Max(14,Len(Field())) + 1
    EndSwitch
    If maxlen.n >= 79 Then
      CtrlHome
      Right
      Return 79
    EndIf
    Right
  EndFor
  CtrlHome
  Right
  Home
  Return maxlen.n
EndProc
;Writelib libname.a maxbarlen.n
;Release Procs maxbarlen.n

;======================================================================
;   Procedure: RecordView.u
;   Copyright: Micah J. Bleecher 1992
;  Programmer: Micah J. Bleecher
; Last Update: 03/09/92
; Description: Gathers and formats current record information to be
;              displayed by popup2.u
;
;====================================================================

Proc RecordView.u()

  Private proc.a, i,width.n,Prompt1.a,Prompt2.a,Emptyf.n,fwidth.n

  proc.a = "recordview.u"

  Clear
  Echo Normal
  Echo Off

  Message.u("Gathering Record Information",True)

  CopyToArray Item

  Width.n = 0
  Emptyf.n = 0
  For i From 1 To ArraySize(Item)  ;Format field values
    If Search("A",Type(Item[i])) = 0 Then
      Item[i]=StrVal(Item[i])
    EndIf
    If Len(Item[i]) < 1 Then
      Item[i]="* Empty Field *"
      emptyf.n = emptyf.n + 1
    EndIf
  EndFor

  CtrlHome


  Array fieldnames.r[ArraySize(Item)]

  fieldnames.r[1]="Table Name: "


  fwidth.n=12

  While FieldNo(Field(),Table()) <> 1 ;rotate fields back to normal
    Rotate
  EndWhile

  CtrlHome
  For i From 2 To ArraySize(Fieldnames.r)     ;format field names
    Right
    Fieldnames.r[i]=Field()
    fwidth.n=Max(fwidth.n,Len(Field()))
  EndFor

  CtrlHome
  Right

  For i From 1 To ArraySize(item)    ;concatenate field names and values
    Item[i]=" "+StrVal(i)+") ["+Fieldnames.r[i]+"]"+
    Fill(".",fwidth.n-Len(fieldnames.r[i]))+" "+Item[i]
    If i < 10 Then
      item[i]=" "+item[i]
    EndIf
    If Len(Item[i]) > 71 Then
      Item[i]=Substr(Item[i],1,71)+"\016"
    EndIf
    Width.n = Max(Len(Item[i]),Width.n)  ;Update max. width
  EndFor

  Prompt1.a = "Vertical Record View Mode: [F2]-Select [Esc]-Return to Lookup Table"
  Prompt2.a = "Current Record Number: ("+StrVal(RecNo())+"), # of Fields: ("+StrVal(ArraySize(Item)-1)+"),"+
  " # of Empty Fields ("+StrVal(Emptyf.n)+")"
  Clear

  Echo Normal
  Echo Off

  popret.a=Popup2.u(4,1,14,1,"Cursor Keys [\018] Scroll Through Fields",Prompt1.a,Prompt2.a,width.n)
  Return popret.a
EndProc
;Writelib libname.a RecordView.u
;Release Procs RecordView.u



;======================================================================
;   Procedure: Popup2.u
;   Copyright: Borland International
;  Programmer: Micah J. Bleecher
; Last Update: 03/09/92
; Description: Modified version of Borlands Copyrighted Popup2 from the
;              DETK. Modifications include, shadow, full length light
;              bar.  Returns -80 if F2 was pressed, "" otherwise
;
;====================================================================

Proc Popup2.u(R,C,VNum,DefItem,Title,Prompt1,Prompt2,width)
  Private proc.a,
  ;R,           ;Row position of upper-left corner of menu box
  ;C,           ;Column position of upper-left corner menu box
  ;VNum,        ;Number of items to be displayed in one menu image
  ;DefItem,     ;Item (number) to show
  ;Title,       ;Title of popup box
  ;Prompt1,     ;First prompt line
  ;Prompt2,     ;Second prompt line
  NItems,      ;Number of items in menu list
  Char,        ;Keycode of last key pressed
  MenuPos,     ;Current (row image) position within menu
  CIndex,      ;Current choice index into Item
  X,           ;Counter variable
  PrmptColr,   ;Color attribute for prompt
  BrdrColr,    ;Color attribute for box border
  ListColr,    ;Color attribute for menu item list
  SlctColr     ;Color attribute for current menu selection
  ;  Global ;Item,        ;Array of items of menu
  ;Width        ;Width of widest item

  proc.a = "popup2.u"

  Clear
  Echo Normal
  Echo Off                     ;Freeze workspace image
  Cursor Off                   ;Hide blinking cursor
  Canvas Off                   ;Disable immediate printing to canvas

  PrmptColr = SysColor(0)      ;Top two line prompt color
  BrdrColr = SysColor(9)       ;Border color
  ListColr = SysColor(17)      ;Menu list color
  SlctColr = SysColor(18)      ;Current menu selection color

  Style Attribute PrmptColr
  @ 0,0             ;Display prompt information
  ?? Spaces(80)+Prompt2+Spaces(80-Len(Prompt2))
  @ 0,0
  ?? Prompt1

  Width = Max(Len(Title),Width)  ;Expand box width if title is too wide

  NItems = ArraySize(Item)     ;Set number of items in list
  If VNum > NItems
    Then VNum = NItems
  EndIf

  Switch
    Case DefItem < VNum :  ;Redraw top screen
      Redraw = 0
      MenuPos = DefItem
    Case DefItem > NItems-VNum :  ;Redraw last screen
      Redraw = NItems-VNum
      MenuPos = DefItem-NItems+VNum
    OtherWise :      ;Redraw intermediate screen
      Redraw = DefItem-1  ;Place item at top of menu
      MenuPos = 1
  EndSwitch

  ;Set default menu settings:
  CIndex = DefItem                     ;First menu item
  LastPos = MenuPos                    ;Last image position is current pos.
  LastIdx = CIndex                     ;Last menu item index

  Style Attribute BrdrColr
  SetMargin C

  ;paint shadow
  PaintCanvas Attribute 7 R+1,C+2,R+Vnum+4,C+width+4

  @ R,C                        ;Draw menu skeleton and initial image
  ?? "",Fill("",Width+2),""
  ? " ",Format("AC,W"+StrVal(Width),Title)," "
  ? "",Fill("",Width+2),""
  For X From 1 To VNum
    ? "",Spaces(Width+2),""
  EndFor
  ?  "",Fill("",Width+2),""

  @ R+3,C+1
  If Redraw = 0                     ;Records above?
    Then ?? " "
  Else ?? ""                    ; Yes- Show items are above
  EndIf
  @ R+VNum+2,C+1
  If Redraw+VNum = NItems           ;Records below?
    Then ?? " "
  Else ?? ""                    ; Yes- Show items are below
  EndIf

  @ R+2,C+2
  SetMargin C+2
  Style Attribute ListColr
  For X From 1 To VNum
    ? Item[X+Redraw]+Spaces(Width-Len(Item[X+Redraw]))
  EndFor
  SetMargin Off

  Canvas On                    ;Reenable immediate echoing to canvas

  Redraw = -1                       ;Disable menu image redraw

  While True

    Style Attribute SlctColr
    @ MenuPos+R+2,C+2         ;Highlight current selection
    ?? Item[CIndex]+Spaces(width-Len(Item[CIndex]))
    Style Attribute ListColr

    Char = GetChar()

    Switch
      Case Char > 31:                        ;First character search?
        For X From CIndex+1 To NItems       ;Search (down) item array
          If Upper(Substr(Item[X],1,1)) = Upper(Chr(Char))
            Then
            QuitLoop                 ;Found a match
          EndIf
        EndFor
        If X = NItems+1                     ;Match not found
          Then Beep
        Else
          If MenuPos+X-CIndex > VNum  ;Is next item already visible?
            Then
            Switch              ; No-
              Case X < VNum :  ;Redraw top screen
                Redraw = 0
                MenuPos = X
              Case X > NItems-VNum :  ;Redraw last screen
                Redraw = NItems-VNum
                MenuPos = X-NItems+VNum
              OtherWise :      ;Redraw intermediate screen
                Redraw = X-1  ;Place item at top of menu
                MenuPos = 1
            EndSwitch
          Else MenuPos = MenuPos+X-CIndex
            Redraw = -1
          EndIf
          CIndex = X                  ;Update current item
        EndIf
      Case Char = -72 :                      ;Up
        If CIndex = 1                       ;Already at first item?
          Then Beep
        Else
          If MenuPos > 1              ;Can move within menu image?
            Then MenuPos = MenuPos-1 ; Yes- Move to previous item
          Else Redraw = CIndex-2   ; No-  Redraw entire menu
          EndIf
          CIndex = CIndex-1           ;Update current item
        EndIf
      Case Char = -80 :                      ;Down
        If CIndex = NItems                  ;On last item?
          Then Beep
          Loop
        Else
          If MenuPos < VNum           ;Can move within menu image?
            Then MenuPos = MenuPos+1    ; Yes-  Move to next item
          Else Redraw = CIndex-VNum+1 ; No- Redraw entire menu
          EndIf
          CIndex=CIndex+1             ;Update current item
        EndIf
      Case Char = -71 :                      ;Home
        If MenuPos <> CIndex                ;Already viewing top of menu?
          Then Redraw = 0                  ; No-  Redraw top of menu
        EndIf
        MenuPos = 1                         ;Position at first item
        CIndex = 1                          ;Select first item
      Case Char = -79 :                      ;End
        If CIndex+VNum-MenuPos <> NItems    ;Already viewing end of menu?
          Then Redraw = NItems-VNum        ; No-  Redraw end of menu
        EndIf
        MenuPos = VNum                      ;Position at bottom of menu
        CIndex = NItems                     ;Select last item
      Case Char = -73 :                      ;PgUp
        If MenuPos = CIndex                 ;Are we within first screen?
          Then Beep                        ; Yes- Disallow PgUp
        Else
          If CIndex-MenuPos-VNum > 0
            Then CIndex = CIndex-MenuPos-VNum+1
          Else CIndex = 1
          EndIf
          Redraw = CIndex-1           ; No-  Redraw previous page
          MenuPos = 1                 ;      Position on that item
        EndIf
      Case Char = -81 :                      ;PgDn
        If CIndex+VNum-MenuPos = NItems ;Are we within last screen?
          Then Beep                        ; Yes- Disallow PgDn
        Else
          If NItems-VNum < CIndex+VNum-MenuPos
            Then CIndex = NItems-VNum+1
          Else CIndex = CIndex+VNum-MenuPos+1
          EndIf
          Redraw = CIndex-1           ; No- Redraw next page
          MenuPos = 1                 ;     Position on that item
        EndIf
      Case Char = -60 : ;13 :
        Cursor Normal                       ;Enter
        Style
        Return Char ;Item[CIndex]                 ;Return selection
      Case Char = 27 :                       ;Esc
        Cursor Normal
        Style
        Return  ""                           ;Return null selection
      OtherWise:                             ;Illegal key
        Beep
    EndSwitch

    If Redraw = -1                            ;Need to redraw entire menu?
      Then @ LastPos+R+2,C+2
      ?? Item[LastIdx]+Spaces(width-Len(Item[LastIDX]))
    Else Canvas Off                        ;Disable immediate canvas echo
      SetMargin C+2
      @ R+2,C+2
      For X From 1 To VNum              ;Redraw entire menu box
        ? Item[Redraw+X]+Spaces(Width-Len(Item[Redraw+X]))
      EndFor
      SetMargin Off
      @ R+3,C+1
      Style Attribute BrdrColr
      If Redraw = 0                     ;Records above?
        Then ?? " "
      Else ?? ""                    ; Yes- Show items are above
      EndIf
      @ R+VNum+2,C+1
      If Redraw+VNum = NItems           ;Records below?
        Then ?? " "
      Else ?? ""                    ; Yes- Show items are below
      EndIf
      Canvas On                         ;Enable immediate canvas echo
      Redraw = -1
    EndIf

    LastPos = MenuPos                         ;Update last row position
    LastIdx = CIndex                          ;Update last item index

  EndWhile

EndProc
;Writelib libname.a Popup2.u
;Release Procs Popup2.u

;======================================================================
;   Procedure: Message.u
;   Copyright: N/A
;  Programmer: Micah J. Bleecher
; Last Update: 02/02/92
; Description: Simple user message routine. Pass message parameter
;   Called By:
;       Calls: None
;
;====================================================================


Proc Message.u(messagestring.a,flash.l)

  Private Proc.a,flashattribute.n

  Proc.a="Message.u"

  If flash.l Then
    flashattribute.n = 128
  Else
    flashattribute.n = 0
  EndIf



  Canvas Off
  @ 15,10 ?? Fill("\223",60)
  @ 16,10 ?? Format("w60,ac",messagestring.a)
  @ 17,10 ?? Fill("\220",60)
  PaintCanvas Attribute 8 16,12,18,70
  PaintCanvas Attribute SysColor(0) 15,10,17,69
  Style Attribute SysColor(0)+flashattribute.n
  @ 16,11 ?? "\249"
  @ 16,68 ?? "\249"
  Style
  Canvas On


EndProc

GenericDemoWait.u()
